/*
 * Copyright (c) 2015, University of Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Robert Gernhardt
 *    Matthias Jung
 *    Felipe S. Prado
 */

#include "PrechargeAllChecker.h"
#include "../../TimingCalculation.h"


void PrechargeAllChecker::delayToSatisfyConstraints(ScheduledCommand &command)
const
{
    sc_assert(command.getCommand() == Command::PrechargeAll);

    // Consider all banks for the constraints, since precharge all command is supposed to happen at the same time on all banks
    for (unsigned int bank = 0; bank < config.memSpec.NumberOfBanks; ++bank) {
        ScheduledCommand lastCommand = state.getLastScheduledCommand(Bank(bank));
        if (lastCommand.isValidCommand()) {
            if (lastCommand.getCommand() == Command::Precharge
                    || lastCommand.getCommand() == Command::PreB) {
                command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                      config.memSpec.tRP);
            } else if (lastCommand.getCommand() == Command::Activate
                       || lastCommand.getCommand() == Command::ActB) {
                command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                      config.memSpec.tRCD);
            } else if (lastCommand.getCommand() == Command::Read) {
                command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                      config.memSpec.tRTP);
            } else if (lastCommand.getCommand() == Command::ReadA) {
                command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                      config.memSpec.tRTP + config.memSpec.tRP);
            } else if (lastCommand.getCommand() == Command::Write) {
                command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                      config.memSpec.tWL + getWriteAccessTime() + config.memSpec.tWR);
            } else if (lastCommand.getCommand() == Command::WriteA) {
                command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                      config.memSpec.tWL + getWriteAccessTime() + config.memSpec.tWR +
                                                      config.memSpec.tRP);
            } else if (lastCommand.getCommand() == Command::AutoRefresh) {
                auto m = Configuration::getInstance().getRefMode();
                if (m == 4)
                    command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                          config.memSpec.tRFC4);
                else if (m == 2)
                    command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                          config.memSpec.tRFC2);
                else
                    command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                          config.memSpec.tRFC);
            } else if (lastCommand.getCommand() == Command::PDNAX
                       || lastCommand.getCommand() == Command::PDNPX) {
                command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                      config.memSpec.tXP);
            } else if (lastCommand.getCommand() == Command::SREFX) {
                command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                      config.memSpec.tXSR);
            } else
                reportFatal("Precharge All Checker",
                            "Precharge  All can not follow " + commandToString(lastCommand.getCommand()));
        }
    }

    ScheduledCommand lastActivate = state.getLastCommand(Command::Activate,
                                                         command.getBank());
    if (lastActivate.isValidCommand()) {
        command.establishMinDistanceFromStart(lastActivate.getStart(),
                                              config.memSpec.tRAS);
    }

    state.bus.moveCommandToNextFreeSlot(command);
}

